function [newstate] = applyA(action, state, rho)

   % Applies an action in a state, yielding a new state 
   % in the adversarial (A) environment.
   % Parameter rho gives the probability that the cat makes a random move.

   global Adversary

   if (rand < rho)
      newstate = applyR(action, state);
      return;
   end

   statevec = statedecode(state);
   actvec = actdecode(action);
   centerstate = [statevec(1:2)+actvec statevec(3:4)];
   newstates = repmat(centerstate,5,1);
   newstates = [ newstates(:,1:2) newstates(:,3:4) + [0 -1;-1 0;0 0;1 0;0 1] ];
   newstates = max(0, newstates);
   newstates = min(3, newstates);

   newnums = statencode(newstates);
   %[junk,ind] = min(Adversary(newnums));
   %newstate = newnums(ind);
   [junk,ind] = sort(Adversary(newnums));
   mins = find(Adversary(newnums)==Adversary(newnums(ind(1))));
   newstate = newnums(mins(ceil(rand*length(mins))));

