function statevec = statedecode(statenum)

   %  Maps state numbers      1     ...    256
   %    to state vectors  [0 0 0 0] ... [3 3 3 3]

   m4 = fix( (statenum - 1) / 64 );
   r4 = rem( (statenum - 1) , 64 );
   m3 = fix( r4 / 16 );
   r3 = rem( r4 , 16 );
   m2 = fix( r3 / 4 );
   r2 = rem( r3 , 4 );
   m1 = fix( r2 / 1 );

   statevec = [m1 m2 m3 m4];

